# 하이퍼패스트 도커 템플릿

하이퍼패스트 도커 템플릿은 Copier를 활용하여 새로운 도커 프로젝트 생성을 간소화하는 강력한 도구입니다. 이 템플릿은 도커 설정을 단순화하고 가속화하여 매우 효율적이고 사용자 친화적인 개발 경험을 제공합니다.

하이퍼패스트 도커 템플릿은 도커의 유연성과 Copier의 단순성을 결합하여 프로젝트 생성 프로세스를 최적화하는 혁신적인 프로젝트 생성 도구입니다. 이 도구를 사용하면 개발자가 빠르고 효율적으로 도커 프로젝트를 설정할 수 있어 전통적으로 이 프로세스와 관련된 시간과 노력을 크게 줄일 수 있습니다.

Copier의 강점을 활용하여 하이퍼패스트 도커 템플릿은 개발자가 최소한의 번거로움으로 도커 프로젝트를 복제할 수 있는 사용자 친화적인 인터페이스를 제공합니다. 이는 광범위한 코딩 지식의 필요성을 제거하여 더 많은 사용자가 도커를 쉽게 접근할 수 있도록 합니다.

또한 이 도구는 하이퍼패스트 접근 방식을 사용하여 도커 프로젝트 템플릿을 만들므로 새 프로젝트를 최대한 빠른 시간 내에 실행할 수 있습니다. 이러한 속도는 생성된 도커 프로젝트의 품질이나 기능을 저하시키지 않고 오히려 성능, 신뢰성 및 확장성을 향상시킵니다.

하이퍼패스트 도커 템플릿은 템플릿 사용으로 모든 프로젝트가 표준화된 레이아웃과 구성을 준수하도록 하여 도커 프로젝트 간의 일관성을 보장합니다. 이는 개발자가 일관된 프로젝트 구조와 구성에 익숙해질 수 있어 생산성과 효율성을 높이는 데 도움이 됩니다.

숙련된 개발자든 초보자든 상관없이 하이퍼패스트 도커 템플릿은 도커 프로젝트 생성 프로세스를 빠르게 진행할 수 있는 이상적인 도구로, 원활하고 효율적이며 생산성이 높은 개발 경험을 보장합니다.

## 사전 요구사항

- 도커
- 도커 컴포즈
- NVIDIA 도커 (GPU 지원을 위해, 선택 사항)

## 설정

1. Copier를 사용하여 템플릿을 프로젝트 디렉토리에 복사합니다:

   ```bash
   copier copy --trust gh:entelecheia/hyperfast-docker-template path/to/destination
   ```

2. 기본 도커 이미지 빌드

   프로젝트 디렉토리로 이동하여 다음 명령을 실행합니다:

   ```bash
   make docker-build-base
   ```

   기본 도커 이미지는 다른 도커 이미지를 빌드하는 데 사용됩니다. 이 이미지는 프로젝트에 필요한 모든 종속성을 설치합니다.

   `docker.base.env` 파일에는 다양한 구성 옵션과 환경 변수가 포함되어 있습니다. `docker-compose.base.yaml` 파일은 이러한 변수를 사용하여 서비스의 동작을 사용자 정의합니다. 이는 개발, 테스트 및 프로덕션 환경에 대해 서로 다른 구성을 설정하려는 경우에 일반적인 관행입니다. `Dockerfile.base` 파일은 이러한 변수를 사용하여 도커 빌드를 사용자 정의합니다. 이러한 파일은 `copier copy` 명령을 실행할 때 Copier에 의해 자동으로 생성됩니다.

3. 애플리케이션 도커 이미지 빌드:

   ```bash
   make docker-build-app
   ```

   애플리케이션 도커 이미지는 애플리케이션을 실행하는 데 사용됩니다. 이 이미지는 애플리케이션과 그 종속성을 설치합니다.

   `docker.app.env` 파일에는 다양한 구성 옵션과 환경 변수가 포함되어 있습니다. `docker-compose.app.yaml` 파일은 이러한 변수를 사용하여 서비스의 동작을 사용자 정의합니다. 이는 개발, 테스트 및 프로덕션 환경에 대해 서로 다른 구성을 설정하려는 경우에 일반적인 관행입니다. `Dockerfile.app` 파일은 이러한 변수를 사용하여 도커 빌드를 사용자 정의합니다. 이러한 파일은 `copier copy` 명령을 실행할 때 Copier에 의해 자동으로 생성됩니다.

4. 도커 컨테이너 시작:

   ```bash
   make docker-up-app
   ```

   이 명령은 이전 단계에서 빌드한 이미지로 도커 컨테이너를 시작합니다. 컨테이너는 애플리케이션을 시작하는 bash 스크립트를 실행합니다.

## 사용 방법

컨테이너를 시작한 후 `localhost:<APP_HOST_WEB_SVC_PORT>`에서 애플리케이션에 액세스할 수 있습니다. 기본적으로 포트는 `18888`로 설정되어 있습니다.

또한 `APP_HOST_SSH_PORT`에 지정된 SSH 포트를 사용하여 컨테이너에 SSH로 접속할 수 있습니다. 기본적으로 포트는 `2222`로 설정되어 있습니다.

### 볼륨

`docker-compose.app.yaml` 파일은 호스트의 디렉토리를 컨테이너의 디렉토리에 바인드 마운트하는 여러 볼륨을 지정합니다. 여기에는 캐시, 작업 공간 디렉토리 및 스크립트 디렉토리가 포함됩니다. 이러한 디렉토리에서 변경된 사항은 컨테이너 재시작 시에도 유지됩니다.

### 문제 해결

이 설정을 사용하는 동안 문제가 발생하면 다음 사항을 확인하세요:

- 도커와 도커 컴포즈가 올바르게 설치되어 있는지 확인하세요.
- GPU 가속을 사용할 계획이라면 NVIDIA 도커가 설치되어 있는지 확인하세요.
- `docker.app.env` 파일의 환경 변수가 올바르게 설정되어 있는지 확인하세요.
- 오류 메시지가 있는지 도커 및 도커 컴포즈 로그를 확인하세요.

### 환경 변수

도커에서 환경 변수는 `docker-compose.app.yaml` 파일에서 서비스의 동작을 사용자 정의하는 데 사용할 수 있습니다.

`docker-compose` 명령에는 `--env-file` 인수가 있지만 `docker-compose.yaml` 파일에 정의된 서비스에 대한 환경 변수를 설정하는 데 사용되며 `docker-compose` 명령 자체에는 사용되지 않습니다. `--env-file`에 정의된 변수는 `docker-compose.yaml` 파일에 대체되지 않습니다.

그러나 `.docker/docker.app.env` 파일에 설정한 환경 변수는 `docker-compose.app.yaml` 파일에서 사용됩니다. 예를 들어 `$BUILD_FROM` 변수는 도커 빌드의 기본 이미지를 설정하는 데 사용됩니다. 따라서 `docker-compose` 명령을 실행하기 전에 이러한 변수를 셸 환경으로 내보내야 합니다.

이 방법은 또한 `USERNAME` 변수에 대한 `"$(whoami)"`와 같이 변수 정의에서 셸 명령을 사용할 수 있게 해줍니다. 이는 `--env-file` 인수를 사용할 경우 불가능합니다. `.env` 파일의 셸 명령은 평가되지 않습니다.

## 추가 정보

하이퍼패스트 도커 템플릿은 도커와 Copier의 강점을 결합하여 개발자가 도커 프로젝트를 더 쉽고 빠르게 설정할 수 있도록 합니다. 주요 이점은 다음과 같습니다:

- **빠른 프로젝트 설정**: 템플릿을 사용하면 개발자가 최소한의 구성으로 도커 프로젝트를 시작할 수 있습니다. 이는 시간을 절약하고 더 빠른 개발 주기를 가능하게 합니다.
- **일관성 유지**: 템플릿을 사용하면 모든 프로젝트에서 동일한 구조와 구성을 사용할 수 있습니다. 이는 프로젝트 간의 일관성을 유지하고 협업을 용이하게 합니다.
- **사용자 정의 가능**: 템플릿은 개발자가 프로젝트의 특정 요구 사항에 맞게 쉽게 사용자 정의할 수 있도록 설계되었습니다. 이는 유연성을 제공하고 다양한 사용 사례에 적응할 수 있게 합니다.

하이퍼패스트 도커 템플릿은 또한 다음과 같은 고급 기능을 제공합니다:

- **NVIDIA GPU 지원**: 템플릿은 NVIDIA 도커를 사용하여 GPU 가속 워크로드를 지원할 수 있습니다. 이는 딥 러닝, 과학 컴퓨팅 등의 분야에서 유용합니다.
- **SSH 액세스**: 템플릿은 SSH를 통해 컨테이너에 액세스할 수 있는 옵션을 제공합니다. 이는 디버깅 및 문제 해결에 유용할 수 있습니다.
- **볼륨 지원**: 템플릿은 호스트와 컨테이너 간에 디렉토리를 공유하기 위해 도커 볼륨을 사용합니다. 이는 데이터 지속성을 가능하게 하고 호스트와 컨테이너 간의 파일 공유를 단순화합니다.

## 요약

하이퍼패스트 도커 템플릿은 도커 프로젝트 생성 프로세스를 간소화하고 가속화하는 강력하고 유연한 도구입니다. Copier의 단순성과 도커의 기능을 결합하여 개발자가 최소한의 노력으로 신속하게 프로젝트를 시작할 수 있도록 합니다.

이 템플릿은 사용하기 쉬운 인터페이스, 사용자 정의 가능한 구성, 고급 기능을 제공하여 다양한 사용 사례와 요구 사항에 적합합니다. 숙련된 개발자와 초보자 모두 하이퍼패스트 도커 템플릿을 사용하여 도커 프로젝트 설정과 관련된 복잡성을 줄이고 개발 프로세스를 간소화할 수 있습니다.

도커 기반 개발의 미래를 향한 발걸음에 있어 하이퍼패스트 도커 템플릿은 개발자가 혁신에 집중하고 더 빠르게 가치를 제공할 수 있도록 지원하는 필수 도구입니다.
